commit f3878885b1aa4ab96b6905d9485a1261934e291b
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Fri Mar 31 13:44:04 2023 +0100

    libstdc++: Teach optimizer that empty COW strings are empty [PR107087]
    
    The compiler doesn't know about the invariant that the _S_empty_rep()
    object is immutable and so _M_length and _M_refcount are always zero.
    This means that we get warnings about writing possibly-non-zero length
    strings into buffers that can't hold them. If we teach the compiler that
    the empty rep is always zero length, it knows it can be copied into any
    buffer.
    
    For Stage 1 we might want to also consider adding this to capacity():
    
            if (_S_empty_rep()._M_capacity != 0)
              __builtin_unreachable();
    
    And this to _Rep::_M_is_leaked() and _Rep::_M_is_shared():
    
              if (_S_empty_rep()._M_refcount != 0)
                __builtin_unreachable();
    
    libstdc++-v3/ChangeLog:
    
            PR tree-optimization/107087
            * include/bits/cow_string.h (basic_string::size()): Add
            optimizer hint that _S_empty_rep()._M_length is always zero.
            (basic_string::length()): Call size().
    
    (cherry picked from commit 4969dcd2b7a94ce6c0d07225b21b5f3c040a4902)

diff --git a/libstdc++-v3/include/bits/cow_string.h b/libstdc++-v3/include/bits/cow_string.h
index 6dd23883429..f79fd879582 100644
--- a/libstdc++-v3/include/bits/cow_string.h
+++ b/libstdc++-v3/include/bits/cow_string.h
@@ -909,17 +909,24 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
 
     public:
       // Capacity:
+
       ///  Returns the number of characters in the string, not including any
       ///  null-termination.
       size_type
       size() const _GLIBCXX_NOEXCEPT
-      { return _M_rep()->_M_length; }
+      {
+#if _GLIBCXX_FULLY_DYNAMIC_STRING == 0 && __OPTIMIZE__
+	if (_S_empty_rep()._M_length != 0)
+	  __builtin_unreachable();
+#endif
+	return _M_rep()->_M_length;
+      }
 
       ///  Returns the number of characters in the string, not including any
       ///  null-termination.
       size_type
       length() const _GLIBCXX_NOEXCEPT
-      { return _M_rep()->_M_length; }
+      { return size(); }
 
       ///  Returns the size() of the largest possible %string.
       size_type

